from __future__ import annotations
from typing import Any, Protocol, runtime_checkable
from com.sun.star.chart2.data import XDataProvider

@runtime_checkable
class XInternalDataProvider(XDataProvider, Protocol):
    def hasDataByRangeRepresentation(self, aRange: str) -> bool: ...
    def getDataByRangeRepresentation(self, aRange: str) -> list[Any]: ...
    def setDataByRangeRepresentation(self, aRange: str, aNewData: sequence< any >) -> None: ...
    def insertSequence(self, nAfterIndex: int) -> None: ...
    def deleteSequence(self, nAtIndex: int) -> None: ...
    def appendSequence(self) -> None: ...
    def insertDataPointForAllSequences(self, nAfterIndex: int) -> None: ...
    def deleteDataPointForAllSequences(self, nAtIndex: int) -> None: ...
    def swapDataPointWithNextOneForAllSequences(self, nAtIndex: int) -> None: ...
    def registerDataSequenceForChanges(self, xSeq: XDataSequence) -> None: ...
    def insertComplexCategoryLevel(self, nLevel: int) -> None: ...
    def deleteComplexCategoryLevel(self, nLevel: int) -> None: ...
    def insertDataSeries(self, nAfterIndex: int) -> None: ...
